std::has_virtual_destructor(3)

NAME
std::has_virtual_destructor - std::has_virtual_destructor

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct has_virtual_destructor;
   If T is a type with a virtual destructor, provides the member constant value equal
   to true. For any other type, value is false.
   If T is a non-union class type, T shall be a complete type; otherwise, the behavior
   is undefined.
   The behavior of a program that adds specializations for has_virtual_destructor
   or has_virtual_destructor_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T >
   inline constexpr bool has_virtual_destructor_v = (since C++17)
   has_virtual_destructor<T>::value; Inherited from std::integral_constant

Member constants
   value true if T has a virtual destructor , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Notes
   If a class has a public virtual destructor, it can be derived from, and the derived
   object can be safely deleted through a pointer to the base object (GotW #18). When
   true, is_polymorphic is true.

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 #include <string>
 #include <stdexcept>
 int main()
 {
     std::cout << std::boolalpha
               << "std::string has a virtual destructor? "
               << std::has_virtual_destructor<std::string>::value << '\n'
               << "std::runtime_error has a virtual destructor? "
               << std::has_virtual_destructor<std::runtime_error>::value << '\n';
 }

Output:
 std::string has a virtual destructor? false
 std::runtime_error has a virtual destructor? true

See also
   is_destructible
   is_trivially_destructible
   is_nothrow_destructible checks if a type has a non-deleted destructor
   (C++11) (class template)
   (C++11)
   (C++11)
   is_polymorphic checks if a type is a polymorphic class type
   (C++11) (class template)